/*
	svg_area.c 
	
	Released under GPL - see the 'COPYING' file   
	
	Copyright (C) 2006 Timo Lassmann <timolassmann@gmail.com>
	
	This program is free software; you can redistribute it and/or modify
	it under the terms of the GNU General Public License as published by
	the Free Software Foundation; either version 2 of the License, or
	any later version.

	This program is distributed in the hope that it will be useful,
	but WITHOUT ANY WARRANTY; without even the implied warranty of
	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
	GNU General Public License for more details.

	You should have received a copy of the GNU General Public License
	along with this program; if not, write to the Free Software
	Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
    
	Please send bug reports, comments etc. to:
	timolassmann@gmail.com
*/

#include <stdio.h>
#include <stdlib.h>
//#include <ctype.h>
#include "msa_viewer.h"
#include "colors.h"
#include "svg_area.h"



void fill_area(struct alignment* aln,int starti,int startj, int px, int py)
{
	
	len = aln->aln_len;
	numseq = aln->numseq;
	//startj = startj+40;
	ci = starti;
	cj = startj;
	l = 0;
	
	int choice = aln->ann[starti][startj];
		
	i = starti;
	j = startj;
	
	fprintf(stdout,"<path d=\"M%d %d ", px,py);   
	
	//i = 0;
	//j = 
	dir = -1;
	//i;
	try_direction(aln,choice);
	
	fprintf(stdout," Z\" fill=\"%s\" />",color_options[choice].hex_code);	
}



void try_direction(struct alignment* aln,int choice)
{
	fprintf(stderr,"%d:	x,%d	y,%d	w:%d	g:%d	\n",i,ci,cj,choice,aln->ann[ci][cj]);
	//i++;
	//if (i > 50){
	//	exit(0);
	//}
	/*if( ci == i &&  cj == j && dir != -1){
		//if(try_right(aln,choice) + try_left(aln, choice) + try_down(aln, choice) + try_up(aln, choice)){
		//	dir = -1;
		//	try_direction(aln,choice);
		//}else{
		switch(dir){
			case 1://is cool
			//	if(!(aln->ann[ci][cj] & (1<< 8))&& !(aln->ann[ci][cj] & (1<< 11)) ){
				
			//	}
				break;
			case 2://is cool
				break;
			case 3:
				if(try_down(aln,choice) ){
					fprintf(stdout,"h%d ",l);
					l  = 0;
					dir = 2;
					aln->ann[ci][cj] |= (1<< 9);
					ci++;
					try_direction(aln,choice);
				}else{
					fprintf(stdout,"h%d ",l-12);
				}
				break;
			case 4:
				break;
			default:
				break;
		}
		//}
	}else{*/
	
	switch(dir){
		case 1:
			 if(try_up(aln,choice)){
			 	fprintf(stdout,"h%d ",l);
				l = 0;
				dir = 4;
				
				if(!(aln->ann[ci][cj] & (1<< 11))){
					aln->ann[ci][cj] |= (1<< 11);
					ci--;
					try_direction(aln,choice);
				}
			}else if(try_right(aln,choice)){
				l += 12;
			
				dir = 1;
				if (!(aln->ann[ci][cj] & (1<< 8))){
					aln->ann[ci][cj] |= (1<< 8);
					cj++;
					try_direction(aln,choice);
				}
			}else if(try_down(aln,choice)){
				fprintf(stdout,"h%d ",l+12);
				l = 20;
				dir = 2;
				if(!(aln->ann[ci][cj] & (1<< 9))){
					aln->ann[ci][cj] |= (1<< 9);
					ci++;
					try_direction(aln,choice);
				}
			}else if(try_left(aln,choice)){
				fprintf(stdout,"h%d ",l+12);
				fprintf(stdout,"v%d ",20);
				l = -12;
				dir = 3;
				if(!(aln->ann[ci][cj] & (1<< 10))){
					aln->ann[ci][cj] |= (1<< 10);
					cj--;
					try_direction(aln,choice);
				}
			}
			break;
		case 2:
			 if(try_right(aln,choice)){
			 
			 	fprintf(stdout,"v%d ",l);
			 	l = 0;
			 
				dir = 1;
				if(!(aln->ann[ci][cj] & (1<< 8))){
					aln->ann[ci][cj] |= (1<< 8);
					cj++;
					try_direction(aln,choice);
				}
			}else if(try_down(aln,choice) ){
				l += 20;
				dir = 2;
				if(!(aln->ann[ci][cj] & (1<< 9))){
					aln->ann[ci][cj] |= (1<< 9);
					ci++;
					try_direction(aln,choice);
				}
			}else if(try_left(aln,choice)){
				fprintf(stdout,"v%d ",l+20);
				l = -12; 
				dir = 3;
				
				if(!(aln->ann[ci][cj] & (1<< 10))){
					aln->ann[ci][cj] |= (1<< 10);
					cj--;
					try_direction(aln,choice);
				}
			}else if(try_up(aln,choice)){
			
				fprintf(stdout,"v%d ",l+20);
				fprintf(stdout,"h%d ",-12);
				l = -20;
				//fprintf(stderr,"v%d ",-20);
			
				dir = 4;
				if(!(aln->ann[ci][cj] & (1<< 11))){
					aln->ann[ci][cj] |= (1<< 11);
					ci--;
					try_direction(aln,choice);
				}
			}
		
			break;
		case 3:
			if(try_down(aln,choice) ){
				fprintf(stdout,"h%d ",l);
				l  = 0;
				dir = 2;
				if(!(aln->ann[ci][cj] & (1<< 9))){
					aln->ann[ci][cj] |= (1<< 9);
					ci++;
					try_direction(aln,choice);
				}
			}else if(try_left(aln,choice)){
				l -= 12;
				dir = 3;
				if(!(aln->ann[ci][cj] & (1<< 10))){
					aln->ann[ci][cj] |= (1<< 10);
					cj--;
					try_direction(aln,choice);
				}
			}else if(try_up(aln,choice)){
				fprintf(stdout,"h%d ",l-12);//??
				//fprintf(stdout,"v%d ",l-12);//??
				l  = -20;
				dir = 4;
				if(!(aln->ann[ci][cj] & (1<< 11))){
					aln->ann[ci][cj] |= (1<< 11);
					ci--;
					try_direction(aln,choice);
				}
			}else if(try_right(aln,choice)){
				fprintf(stdout,"h%d ",l-12);
				fprintf(stdout,"v%d ",-20);
				
				l = 12; 
				dir = 1;
				if(!(aln->ann[ci][cj] & (1<< 8))){
					aln->ann[ci][cj] |= (1<< 8);
					cj++;
					try_direction(aln,choice);
				}
			}
			 
			break;
		case 4:
			 if(try_left(aln,choice)){
			 	fprintf(stdout,"v%d ",l);
			 	l = 0;
				dir = 3;
				if(!(aln->ann[ci][cj] & (1<< 10))){
					aln->ann[ci][cj] |= (1<< 10);
					cj--;
					try_direction(aln,choice);
				}
			}else if(try_up(aln,choice)){
				l -= 20;
				dir = 4;
				if(!(aln->ann[ci][cj] & (1<< 11))){
					aln->ann[ci][cj] |= (1<< 11);
					ci--;
					try_direction(aln,choice);
				}
			}else if(try_right(aln,choice)){
				fprintf(stdout,"v%d ",l-20);
				l = 12;
				dir = 1;
				if(!(aln->ann[ci][cj] & (1<< 8))){
					aln->ann[ci][cj] |= (1<< 8);
					cj++;
					try_direction(aln,choice);
				}
			}else if(try_down(aln,choice) ){
				fprintf(stdout,"v%d ",l-20);
				fprintf(stdout,"h%d ",12);
				l = 20;
				dir = 2;
				if(!(aln->ann[ci][cj] & (1<< 9))){
					aln->ann[ci][cj] |= (1<< 9);
					ci++;
					try_direction(aln,choice);
				}
			}
			break;
		default:
			if(try_up(aln,choice)){
				l -= 20;
				dir = 4;
				aln->ann[ci][cj] |= (1<< 11);
				ci--;
				try_direction(aln,choice);
			}else if(try_right(aln,choice)){
				dir = 1;
				l += 12;
				aln->ann[ci][cj] |= (1<< 8);
				cj++;
				try_direction(aln,choice);
			}else if(try_down(aln,choice)){
				fprintf(stdout,"h%d ",12);
				l += 20;
				dir = 2;
				aln->ann[ci][cj] |= (1<< 9);
				ci++;
				try_direction(aln,choice);
			}else  if(try_left(aln,choice)){
				fprintf(stdout,"h%d ",12);
				fprintf(stdout,"v%d ",20);
				dir = 3;
				l -= 12;
				aln->ann[ci][cj] |= (1<< 10);
				cj--;
				try_direction(aln,choice);
			}else{
				fprintf(stdout,"h12 v20 h-12 ");
			}
			break;
	}
// 	//}
	/*
	if(try_right(aln,choice) && dir != 3){
		dir = 1;
		aln->ann[ci][cj] |= (1<< 8);
		cj++;
		try_direction(aln,choice);
	}else if(try_down(aln,choice) && dir != 4){
		dir = 2;
		aln->ann[ci][cj] |= (1<< 9);
		ci++;
		try_direction(aln,choice);
	}else if(try_left(aln,choice) && dir != 1){
		dir = 3;
		aln->ann[ci][cj] |= (1<< 10);
		cj--;
		try_direction(aln,choice);
	}else if(try_up(aln,choice)&& dir != 2){
		dir = 4;
		aln->ann[ci][cj] |= (1<< 11);
		ci--;
		try_direction(aln,choice);
	}*/
	
}


int try_right(struct alignment* aln,int choice)
{
	if(cj+1 < len   ){
		if(choice == (aln->ann[ci][cj+1]& 0xff)){
			return 1;
		}
	}
	return 0;
}

int try_down(struct alignment* aln,int choice)
{
	if(ci+1 < numseq  ){
		if(choice == (aln->ann[ci+1][cj]& 0xff)){
			return 1;
		}
	}
	return 0;
}

int try_left(struct alignment* aln,int choice)
{
	if(cj-1 >=0 ){
		if(choice == (aln->ann[ci][cj-1]& 0xff)){
			return 1;
		}
	}
	return 0;
}

int try_up(struct alignment* aln,int choice)
{
	if(ci-1 >= 0 ){
		if(choice == (aln->ann[ci-1][cj]& 0xff)){
			return 1;
		}
	}
	return 0;
}


